
		.if (JIFFYDOS_ACCEL=1) & (SUPERCPU=0)

iecdevnotp	jmp $edad		;device not present

iectalk		.proc			;ed09
		ora #$40
		.byte SKIP2

ieclisten	.proc			;ed0c
		ora #$20
		jsr $f0a4		;serial bus idle

iec_ed11	.proc			;ed11
		bit $94
		bpl atr
		pha
		sec
		ror $a3
		jsr jiffy_fbfe
		lsr $94
;		lsr $a3
		pla
atr		sta $95
		sei
		jsr jiffy_f0ed		;clear $a3 and datahi
		cmp #$3f
		bne *+5
		jsr $ee85		;clkhi
		lda $dd00		;atnlo
		ora #8
		sta $dd00

iec_ed36	.proc			;ed36
		sei
		jsr $ee8e		;clklo
		jsr $ee97		;datahi
		jsr $eeb3		;1ms delay

iecsend		.proc
		sei			;ed40
		jsr $ee97		;datahi
		jsr $eea9		;getdataclk
		bcs iecdevnotp		;data low?
		jsr $ee85		;clkhi
		bit $a3
		bpl id
		jsr $eea9		;getdataclk
		bcc *-3			;wait datahi
		jsr $eea9		;getdataclk
		bcs *-3			;wait datalo
id		jsr $eea9		;getdataclk
		bcc *-3			;wait datahi
		jsr $ee8e		;clklo
		lda #8
		sta $a5
jw		lda $dd00
		cmp $dd00
		bne jw
		asl
		bcs oj
		jmp $edb0		;timeout

oj		ror $95

		nop
		lda $dd00
		and #$df
		bcs *+4
		ora #$20		;datalo (send bit)
		sta $dd00
		jsr $ee85		;clkhi
		cmp (0,x)
		nop
		lda $dd00
		and #$df
		ora #$10
		sta $dd00
		and #$08
		beq ex			;addressing?

		lda $a5
		eor #$02
		bne ex			;last bit?

		lda #$1e+1
sc		bit $dd00
		bpl ll
		sbc #1
		bne sc
		geq ex

ll		bit $dd00
		bpl *-3
		lda $95
		sec
		ror
		ror
		sta $a3			;jiffydrive found!
ex
		dec $a5
		bne jw
		jmp $ed92
		.pend

iecsecond	.proc			;edb9
		sta $95
		jsr iec_ed36
		jmp $edbe		;atnhi
		.pend

iectksa		.proc			;edc7
		sta $95
		jsr iec_ed36
		jmp $edcc		;wait for clock
		.pend

iecout		.proc			;eddd
		bit $94
		bmi ie
		sec
		ror $94
		bne la
ie		pha
		jsr jiffy_fbfe
		pla
la		sta $95
		clc
		rts
		.pend

iecuntalk	.proc			;edef
		sei
		lda $dd00		;atnlo
		ora #$08
		sta $dd00
		jsr $ee8e		;clklo
		lda #$5f
		.byte SKIP2

iecunlisten	.proc			;edfe
		lda #$3f
		jsr iec_ed11
		jmp $ee03
		.pend

jiffy_fbfe	.proc			;JiffyDos send
		sei
		bit $a3
		bvc ms			;jiffydrive?
jf		lda $d015
		beq ss
		pha
		jsr jiffy_f0d8		;spriteoff
		jsr ss
		pla
		sta $d015
		rts

ms		lda $a3
		cmp #$a0
		bcs jf
		gcc iecsend

ss		txa
		pha
		lda $95
		and #$f0
		pha
		lda $95
		and #$0f
		tax
		lda $dd00
		bpl *-3
		and #7
		sta $95
                .if 0			;CMD HD SAVE?
iw		sec
		lda $d012
		sbc #$27
                bcc kk
		sbc $d011
		and #7
		beq iw
kk		lda $95
		.else
                sec
iw              lda $d012
                sbc $d011
                and #7
                cmp #6
                bcs iw
                lda $95
		.fi
		sta $dd00
		pla
		ora $95
		sta $dd00
		lsr
		lsr
		and #$f0
		ora $95
		sta $dd00
		lda tb,x
		ora $95
		sta $dd00
		lsr
		lsr
		and #$f0
		ora $95
		sta $dd00
		and #$0f
		bit $a3
		bmi *+4
		ora #$10
		sta $dd00
		pla
		tax
		lda $95
		ora #$10
		sta $dd00
		bit $dd00
		bmi $edb0
		cli
		clc
		rts

tb		.byte $00,$80,$20,$a0,$40,$c0,$60,$e0
		.byte $10,$90,$30,$b0,$50,$d0,$70,$f0
		.pend

jiffy_f0ed	.proc
		lda #0
		sta $a3
		jmp $ee97		;datahi
		.pend

iecin		.proc			;fbaa JiffyDos get
		sei
		bit $a3
		bvc old			;jiffy drive?
		lda $d015
		beq lp
		pha
		jsr jiffy_f0d8		;spriteoff
		jsr lp
		pla
		sta $d015
		lda $a4
		rts

old		lda #$00
		jmp $ee16

lp		lda $dd00		;fbb4
		cmp #$40
		bcc lp
		and #7
		pha
lp2		sec
		lda $d012
		sbc #$27
                bcc kk
		sbc $d011
		and #7
		beq lp2
kk		pla
		sta $dd00
                sta $a4
		ora #$20
		pha
                nop
                nop
		ora $dd00
		lsr
		lsr
		nop
		ora $dd00
		lsr
		lsr
		eor $a4
		eor $dd00
		lsr
		lsr
		eor $a4
		eor $dd00
		sta $a4
		pla
		bit $dd00
		sta $dd00
		bvc exit
		bpl last
		lda #$42
		jmp $edb2

last		lda #$40
		jsr $fe1c
exit		lda $a4
		cli
		clc
		rts
		.pend

		.else

iectalk		= $ed09
ieclisten	= $ed0c
iecsecond	= $edb9
iectksa		= $edc7
iecout		= $eddd
iecuntalk	= $edef
iecunlisten	= $edfe
iecin		= $ee13

		.fi

jiffy_f0d8	.proc			;sprite off and delay
		#lda0
		sta $d015
lp		adc #1
		bne lp
		rts
		.pend

